---
---  \file wrap__t_array2.lua
---  \brief Lua  wrapper for 2D _t_type Arrays
---
---


_t_a2Cols=function(a)
	  local cols={}
	  for i=1,a2NCol(a) do
	     tinsert(cols,a2Col(a,i))
	  end
	  return col
       end

_t_a2Rows=function(a)
	  local rows={}
	  for i=1,a2NRow(a) do
	     tinsert(rows,a2Row(a,i))
	  end
	  return rows
       end

-------------------------------------------------------------------------------
--- \LuaOnly Construct 2D double array from constructor table.
--- 
--+ _T_Array2 * _T_Array2(table desc);
--- 
function _T_Array2(desc)
   local fill=0,nrow,ncol,a
   if not desc then
      return nil
   elseif istype(desc,"_T_Array2") then
      return desc
   elseif desc.nrow and desc.ncol then
      a=mbase._t_a2Create(desc.nrow, desc.ncol)
   elseif table.getn(desc)>0 and table.getn(desc[1])>0 then
      nrow=table.getn(desc)
      ncol=table.getn(desc[1])
      fill=1
      a=mbase._t_a2Create(nrow,ncol)
   elseif desc.ncol then
      a=mbase._t_a2Create(0,desc.ncol)
   else
      a=mbase._t_a2Create(0,0)
   end
   if fill==1 then
      local i,j
      for i=1,nrow do
	 for j=1,ncol do
	    mbase._t_a2Set(a,i,j,desc[i][j])
	 end
      end
   end
   return a
end


if not _array2 then _array2={} end
_array2["_t_type_"]=_T_Array2

--[[
_T_Array2.__index_old=_T_Array2.__index;

function _T_Array2.__index(v,idx) 
   if type(idx)=="number" then
      return _t_a2XRowVal(v,idx).v
   else
      return _T_Array2.__index_old(v,idx)
   end
end



_T_Array2.addref=_t_a2Addref
_T_Array2[".eq"]=doteq
getmetatable(_T_Array2)["__call"]=callnew
getmetatable(_T_Array2)["__eq"]=nil -- class equality problem in tolua ?
]]
