help=[[
         Vector viewer for pdelib2.
Usage:
   
   [pdelib2] particles [inputfile [assignments|switches] ]

Input:
   
   inputfile must be .vec
   

COMMAND LINE SWITCHES

   -h             This help.
   
   grid=<gfile>   Associated grid file
                   *) <gfile>.th process taylor hood data
                   *) otherwise read with gRead(<gfile>)
   
   dtype=0        Data set type: 0=stationary
                                 1=time dependend
   
   param=<file>   Load parameter file.
   
   tdru=0         Debug print of algorithm and param config
   
   fstart=0       Start value of file counter.
                  Changes only the print out.
]]


processargs(arg)

vfile=arg.files[1]
gfile=arg.values.grid
param=arg.values.param
dtype=arg.values.dtype
tdru=arg.values.tdru
fstart=arg.values.fstart

if arg.switches.h then print(help) return end
if not vfile then print("unspecified .vec file") return end
if not dtype then print("unspecified parameter dtype=") return end
if not gfile then print("unspecified grid file") return end

glv2SetStateFile(filePrefFile("particles.ini"))

if not tdru then
 tdru=0
end

if not fstart then
 fstart=0
end


config=vfCreateParticleConfig()
if param then
 config:loadFromFile(param)
end
if tdru > 0 then
 config:print()
end

if not config:isValid() then
 print("parameter file invalid!\n aborting ...")
 return
end


viewer=glvCreate(0,0, 400,400, "particles");

if dtype == 0 then
 vfTraceViewInitS(viewer, gfile, vfile, config, tdru);
else
 vfTraceViewInitT(viewer, gfile, vfile, config, tdru, fstart, "vec"); 
end

glvWait()

vfTraceViewOffline(viewer)

glvWait()




