--- 
--- 
--- \brief Lua wrapper for glViewer class.
--- \file glviewer.lua
---


------------------------------------------------
---
---  \brief
--- \luaonly Alternative Constructor for glviewer.
---
--- Construct glviewer with named parameters.
--- \param desc Description table with optional arguments
--- <ul>
---   <li>x: x pos
---   <li>y: y pos
---   <li>w: width
---   <li>h: height
---   <li>title: title
---  </ul>
---
--- \return viewer.
--- 
--+  function  glvNew(desc);
---
 
 function glvNew(...)
   local desc=arg[1]	
 
   local title ,x,y,w,h,mydesc,r
   title="pdelib2"
   x=0
   y=0
   w=400
   h=300
   if desc then
      if desc.title then title=desc.title end
      if desc.x then x=desc.x end
      if desc.y then y=desc.y end
      if desc.w then w=desc.w end
      if desc.h then h=desc.h end
   end
   if w<50 or h<50 then
      error("glViewer: Wrong window dimensions: "..w.." x "..h)
   end
   r=mgraphic.glvCreate(x,y,w,h,title)
   return r	
end

glViewer=glvNew

-------------------------------------------
---
--- \brief set data for glviewer
---
---

function glvView(viewer,object,...)
 if istype(object,"Grid") then
    grid.gView(viewer,object)
 elseif istype(object,"DArray1") then
    grid.da1View(viewer,object)
 elseif istype(object,"DArray2") then
    grid.da2View(viewer,object,arg[1])
 end
end


----------------------------------------------------
--- 
---  \brief
---   \luaonly  Lua extension of glViewer class.  
--- 

--+  class  glViewerClass: public  glViewer{
--+    public:
--+   continue(); //< continue
--+   wait(); //<wait
--+   new(); //< new
--+ }

--[[
glViewer.new=glvNew
glViewer.view=glvView
glViewer.wait=glvWait
glViewer.show=glvShow
getmetatable(glViewer)["__call"]=callnew
]]

function  glvSetObject(viewer,draw,data)
  swigext_virtual("mgraphic","glViewer","drawobject",draw)
  swigext_extend(viewer,"drawobjectdata")
  viewer.drawobjectdata=data
  viewer.docallv=1
  mgraphic.glvRefreshObject(viewer) 
end


